// Iterative insertion sort for arrays

def insertionSort(A: Array[Int]) {
  for (last <- 1 until A.length ) {
    // A(0..last-1) already sorted
    val x = A(last)
    var i = last
    while (i > 0 && x < A(i-1)) {
      A(i) = A(i-1)
      i = i-1
    }
    A(i) = x
  }
}

val A = new Array[Int](100000)
for (i <- 0 until A.length)
  A(i) = (math.random * 1000).toInt
println(A.mkString(" "))
insertionSort(A)
println(A.mkString(" "))
