// Merge sort

def merge(L1: List[Int], L2: List[Int]): List[Int] = {
  val L = new scala.collection.mutable.ListBuffer[Int]
  var A = L1
  var B = L2
  while (A.nonEmpty && B.nonEmpty) {
    if (A.head < B.head) {
      L += A.head
      A = A.tail
    } else {
      L += B.head
      B = B.tail
    }
  }
  L ++= A
  L ++= B
  L.toList
}

def mergeSort(L: List[Int]): List[Int] = {
  if (L.length > 1) {
    val m = L.length / 2
    val L1 = mergeSort(L take m)
    val L2 = mergeSort(L drop m)
    merge(L1, L2)
  } else
    L
}

/*
var L: List[Int] = Nil
for (i <- 1 to 100000)
  L = (math.random * 1000).toInt :: L
println(L)
val S = mergeSort(L)
println(S)
*/

import scala.compat.Platform.currentTime
var L: List[Int] = Nil
for (i <- 1 to 1000000)
  L = (math.random * 10000000).toInt :: L
println(L take 30)
val t0 = currentTime
val S = mergeSort(L)
val t1 = currentTime
println(S take 30)
printf("Sorting %d numbers took %d milliseconds\n", L.length, t1 - t0)
