// In-place Quick-Sort

def quickSort(A: Array[Int], lo: Int, hi: Int) {
  if (lo < hi) {
    val pivotIndex = partition(A, lo, hi)
    quickSort(A, lo, pivotIndex - 1)
    quickSort(A, pivotIndex + 1, hi)
  }
}

def partition(A: Array[Int], lo: Int, hi: Int): Int = {
  val p = lo + (math.random * (hi - lo + 1)).toInt
  val pivot = A(p)
  A(p) = A(hi)  // Swap pivot with last item
  A(hi) = pivot

  var i = lo - 1
  var j = hi
  do {
    do { i += 1 } while (A(i) < pivot)
    do { j -= 1 } while ((A(j) > pivot) && (j > lo))
    if (i < j) {
      val t = A(i); A(i) = A(j); A(j) = t
    }
  } while (i < j)
  
  A(hi) = A(i)
  A(i) = pivot // Put pivot where it belongs
  i
}

val A = new Array[Int](100000)
for (i <- 0 until A.length)
  A(i) = (math.random * 1000).toInt
println(A.mkString(" "))
quickSort(A, 0, A.length - 1)
println(A.mkString(" "))
